package robotarm_profile.service.invoker;

import java.text.SimpleDateFormat;
import java.util.GregorianCalendar;

import org.robotservices.custom_profile.lib.common.util.CustomProfileConst;
import org.robotservices.custom_profile.lib.common.util.XMLUtil;
import org.robotservices.custom_profile.lib.service.invoker.InvokerCustomProfileBase;
import org.robotservices.custom_profile.lib.service.invoker.PushDataCustomProfile;
import org.robotservices.schemas.v02.common_profile.RetValue;
import org.robotservices.schemas.v02.common_profile.RoboHeader;
import org.robotservices.v02.exception.RSiException;

import robotarm_profile.common.RobotarmProfileConst;
import robotarm_profile.common.Robotarm_profile_move_arm;

public class RobotarmProfileInvoker extends InvokerCustomProfileBase {

	/**
	 * SVtoCL
	 * @param xml
	 * @return
	 * @throws RSiException
	 */
	public RetValue moveArm(double joint1, double joint2, double joint3, double joint4, double joint5) throws RSiException {

		//ここでＸＭＬを作って、下に送信を委譲する
		RoboHeader roboHeader =new RoboHeader();
		roboHeader.setDirection(CustomProfileConst.ROBO_HEADER_DIRECTION.SVtoCL.toString());
		roboHeader.setMessageId("messageId");
		roboHeader.setMessageType(CustomProfileConst.ROBO_HEADER_MESSAGE_TYPE.sync.toString());
		roboHeader.setLastReply(false);
		SimpleDateFormat sdf = new SimpleDateFormat(CustomProfileConst.ROBO_HEADER_TIMESTAMP_PATTERN);
		String timeStamp = sdf.format(GregorianCalendar.getInstance().getTime());
		roboHeader.setTimestamp(timeStamp);
		roboHeader.setVersion(CustomProfileConst.ROBO_HEADER_VERSION.toString());

		Robotarm_profile_move_arm robotarm_profile_move_arm = new Robotarm_profile_move_arm();
		robotarm_profile_move_arm.setRoboHeader(roboHeader);
		robotarm_profile_move_arm.setJoint1_radian(joint1);
		robotarm_profile_move_arm.setJoint2_radian(joint2);
		robotarm_profile_move_arm.setJoint3_radian(joint3);
		robotarm_profile_move_arm.setJoint4_radian(joint4);
		robotarm_profile_move_arm.setJoint5_radian(joint5);

		//XML化
		String xml = XMLUtil.marshal(robotarm_profile_move_arm);

		PushDataCustomProfile pushDataCustomProfile = new PushDataCustomProfile(this.getConvId(),this.getInvokerProfileFactory());
		String returnXml = pushDataCustomProfile.pushDataCustomProfile(RobotarmProfileConst.CLIENT_ACCEPTOR_CUSTOM_PROFILE_NAME,RobotarmProfileConst.OPERATION_NAME_MOVE_ARM, xml);

		RetValue retValue = XMLUtil.unmarshal(returnXml, RetValue.class);

		return retValue;
	}

}